﻿using Syncfusion.SfSchedule.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Text;
using Xamarin.Forms;

namespace Schedule_Appointment
{
    public class ScheduleViewModel : INotifyPropertyChanged
    {
        private List<string> subjectCollection;
        private List<Color> color_collection;

        private ScheduleAppointmentCollection appointments;

        public ScheduleAppointmentCollection Appointments
        {
            get { return appointments; }
            set
            {
                appointments = value;
                RaiseOnPropertyChanged("Appointments");
            }
        }

        public ScheduleViewModel()
        {
            Appointments = new ScheduleAppointmentCollection();
            InitializeDataForBookings();
            BookingAppointments();
        }
        private void BookingAppointments()
        {
            Random randomTime = new Random();
            List<Point> randomTimeCollection = GettingTimeRanges();

            DateTime date;
            DateTime DateFrom = DateTime.Now.AddDays(-10);
            DateTime DateTo = DateTime.Now.AddDays(10);
            DateTime dateRangeStart = DateTime.Now.AddDays(-3);
            DateTime dateRangeEnd = DateTime.Now.AddDays(3);

            for (date = DateFrom; date < DateTo; date = date.AddDays(1))
            {
                if ((DateTime.Compare(date, dateRangeStart) > 0) && (DateTime.Compare(date, dateRangeEnd) < 0))
                {
                    for (int AdditionalAppointmentIndex = 0; AdditionalAppointmentIndex < 3; AdditionalAppointmentIndex++)
                    {
                        ScheduleAppointment meeting = new ScheduleAppointment();
                        int hour = (randomTime.Next((int)randomTimeCollection[AdditionalAppointmentIndex].X, (int)randomTimeCollection[AdditionalAppointmentIndex].Y));
                        meeting.StartTime = new DateTime(date.Year, date.Month, date.Day, hour, 0, 0);
                        meeting.EndTime = (meeting.StartTime.AddMinutes(30));
                        meeting.Subject = subjectCollection[randomTime.Next(9)];
                        meeting.Color = color_collection[randomTime.Next(9)];
                        meeting.IsAllDay = false;
                        Appointments.Add(meeting);
                    }
                }
                else
                {
                    ScheduleAppointment meeting = new ScheduleAppointment();
                    meeting.StartTime = new DateTime(date.Year, date.Month, date.Day, randomTime.Next(9, 11), 0, 0);
                    meeting.EndTime = (meeting.StartTime.AddDays(2).AddHours(1));
                    meeting.Subject = subjectCollection[randomTime.Next(9)];
                    meeting.Color = color_collection[randomTime.Next(9)];
                    meeting.IsAllDay = true;
                    Appointments.Add(meeting);
                }
            }
        }

        private List<Point> GettingTimeRanges()
        {
            List<Point> randomTimeCollection = new List<Point>();
            randomTimeCollection.Add(new Point(9, 11));
            randomTimeCollection.Add(new Point(12, 14));
            randomTimeCollection.Add(new Point(15, 17));

            return randomTimeCollection;
        }

        private void InitializeDataForBookings()
        {
            subjectCollection = new List<string>();
            subjectCollection.Add("General Meeting");
            subjectCollection.Add("Plan Execution");
            subjectCollection.Add("Project Plan");
            subjectCollection.Add("Consulting");
            subjectCollection.Add("Performance Check");
            subjectCollection.Add("Yoga Therapy");
            subjectCollection.Add("Plan Execution");
            subjectCollection.Add("Project Plan");
            subjectCollection.Add("Consulting");
            subjectCollection.Add("Performance Check");

            color_collection = new List<Color>();
            color_collection.Add(Color.FromHex("#FF339933"));
            color_collection.Add(Color.FromHex("#FF00ABA9"));
            color_collection.Add(Color.FromHex("#FFE671B8"));
            color_collection.Add(Color.FromHex("#FF1BA1E2"));
            color_collection.Add(Color.FromHex("#FFD80073"));
            color_collection.Add(Color.FromHex("#FFA2C139"));
            color_collection.Add(Color.FromHex("#FFA2C139"));
            color_collection.Add(Color.FromHex("#FFD80073"));
            color_collection.Add(Color.FromHex("#FF339933"));
            color_collection.Add(Color.FromHex("#FFE671B8"));
            color_collection.Add(Color.FromHex("#FF00ABA9"));

        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaiseOnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
